'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (NormalizedCollection, normalizedCollectionName, attribute, attributeName) {
  return function normalize(actions, model) {
    // get the data we need to inspect for normalization
    var data = model.attributes[attributeName];

    // if the data is NOT a plain object, we can't normalize it, so bail out
    if (!_lodash2.default.isArray(data)) return;

    var collection = new NormalizedCollection(attribute.parse ? attribute.parse(data) : parse(data));
    var combinedQuery = attribute.query ? attribute.query(model) : query(model);

    actions.push({
      type: _ActionTypes2.default.fetchPlural(normalizedCollectionName),
      payload: (0, _payloadCollection2.default)(collection, _PayloadStates2.default.RESOLVED, null, combinedQuery),
      query: combinedQuery
    });
  };
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ActionTypes = require('../ActionTypes');

var _ActionTypes2 = _interopRequireDefault(_ActionTypes);

var _PayloadStates = require('../PayloadStates');

var _PayloadStates2 = _interopRequireDefault(_PayloadStates);

var _payloadCollection = require('../payloadCollection');

var _payloadCollection2 = _interopRequireDefault(_payloadCollection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parse(data) {
  return data;
}

function query(model) {
  return {};
}

module.exports = exports['default'];