'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (NormalizedModel, normalizedModelName, attributeName) {
  return function normalize(actions, model) {
    // get the data we need to inspect for normalization
    var data = model.attributes[attributeName];

    // if the data is NOT a plain object, we can't normalize it, so bail out
    if (!_lodash2.default.isArray(data)) return;

    data.forEach(function (datum) {
      var normalizedModel = new NormalizedModel(datum);

      actions.push({
        type: _ActionTypes2.default.update(normalizedModelName),
        payload: (0, _payload2.default)(normalizedModel, _PayloadStates2.default.RESOLVED)
      });
    });
  };
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _ActionTypes = require('../ActionTypes');

var _ActionTypes2 = _interopRequireDefault(_ActionTypes);

var _PayloadStates = require('../PayloadStates');

var _PayloadStates2 = _interopRequireDefault(_PayloadStates);

var _payload = require('../payload');

var _payload2 = _interopRequireDefault(_payload);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = exports['default'];